import 'package:flutter/cupertino.dart';
import 'ReponseState.dart';

abstract class CommonProvider<T> with ChangeNotifier {
  ResponseState<List<T>> objectData;
  @protected
  @mustCallSuper
  CommonProvider() {
    InitReponseState();
  }
  @protected
  @mustCallSuper
  void InitReponseState() {
    objectData = ResponseState<List<T>>(ResponseData: List<T>());
  }

  @protected
  @mustCallSuper
  void UpdateState(ResponseState response, {bool append = false}) {
    objectData.State = response.State ?? objectData.State;
    objectData.Exception = response.Exception ?? '';
    if (append) {
      var data = response.ResponseData as List<T>;
      data.length > 0
          ? objectData.ResponseData.addAll(data)
          : objectData.ResponseData;
    } else
      objectData.ResponseData =
          response.ResponseData ?? objectData.ResponseData;
    notifyListeners();
  }
}
