enum StateOfResponse { BEGIN, LOADING, COMPLETE, ERROR }

class ResponseState<T> {
  StateOfResponse State;
  T ResponseData;
  String Exception;
  ResponseState({this.State, this.ResponseData, this.Exception});

  static ResponseState<T> RequestBegin<T>() =>
      ResponseState(State: StateOfResponse.BEGIN);

  static ResponseState<T> RequestLoading<T>() =>
      ResponseState(State: StateOfResponse.LOADING);

  static ResponseState<T> RequestComplete<T>(T data) =>
      ResponseState(State: StateOfResponse.COMPLETE, ResponseData: data);

  static ResponseState<T> RequestFail<T>(String exception) =>
      ResponseState(State: StateOfResponse.ERROR, Exception: exception);
}
